{program MD5.
  V2.1, 01.2005/<<>> PARAllel MINDs Cooperation.
  Programmbeispiel fuer die Anwendung der MD5-Hashwert-Berechnung mit Hilfe
  der Unit Crypt2.pas.
  16Bit DOS-Version/Turbo Pascal 6.
  Aufruf s.u. ShowInfo.}

{$D-,L-,B-,S+,R-,I-,V+}

uses
  Dos,
  Crypt2;                          {V2.25, enthaelt MD5-Berechnungsroutinen};

const
  ProgVer='V2.1';
  ProgTitle='01.2005, <<>> PARAllel MINDs Cooperation';
  LogFileName='MD5.LOG';

procedure ShowInfo;
  {Info auf Bildschirm ausgeben}
var i:byte;
begin
  writeln;
  writeln('MD5 Message-Digest/',ProgVer,', ',ProgTitle,'.');
  writeln('Algorithmus von Ron Rivest, RSA Data Security.');
  writeln('16Bit DOS-Version.');
  for i:=1 to 64 do write('-');writeln;
  writeln('Aufruf: MD5 [<Datei>] [-t<Text>] [-l] [-n]');
  writeln('  <Datei>       : Dateiname zur MD5-Berechnung');
  writeln('  -t<Text>      : Zeichenfolge zur MD5-Berechnung');
  writeln('  -l            : MD5-Ergebnis in Logdatei ',LogFileName,' schreiben');
  writeln('  -n            : MD5-Ergebnis als Dateinamen schreiben (nur DOS7)');
  writeln('  ohne Parameter: Interaktiver Modus');
  writeln
end;

procedure ShowMenuLine(IModeFileReq:boolean);
  {Menuezeile auf Bildschirm}
var s1,s2:string[8];
begin
  if IModeFileReq then begin s1:='Text=T';s2:='Datei' end
  else begin s1:='Datei=D';s2:='Text' end;
  write('MD5 (',s1,', Ende=E) * ',s2,': ')
end;

function Byte2HStr(b:byte):NameStr;
  {Byte als Hex-String rueckliefern}
const HexChr:array[0..15] of char='0123456789abcdef';
begin
  Byte2HStr:=hexChr[b shr 4]+HexChr[(b) and $0f]
end;

function CutDir(Path:ComStr):ComStr;
  {Dateinamen ohne Verzeichnis rueckliefern}
var i:byte;
begin
  i:=Length(Path);while (i>0) and (Pos(Path[i],':\')=0) do Dec(i);
  CutDir:=Copy(Path,i+1,Length(Path)-i)
end;

procedure CreateLFNFile(LFNPath:string;var FileHandle:word);
  {LFN-Datei anlegen, nur DOS7}
var i:byte;Regs:Registers;
begin
  i:=Length(LFNPath);Move(LFNPath[1],LFNPath[0],i);LFNPath[i]:=#0;
  Regs.AX:=$716C;Regs.BX:=$2402;Regs.CX:=$20;Regs.DX:=$12;
  Regs.DS:=Seg(LFNPath);Regs.SI:=Ofs(LFNPath);Regs.DI:=$00;
  Intr($21,Regs);
  FileHandle:=Word(Regs.AX)
end;

procedure CloseLFNFile(FileHandle:word);
  {LFN-Datei schliessen, nur DOS7}
var Regs:Registers;
begin
  Regs.AH:=$3E;Regs.BX:=FileHandle;
  Intr($21,Regs)
end;

procedure GetCommLinePars(var TStr,FStr,LStr,NStr:ComStr;var InModeReq:boolean);
  {Kommandozeilen-Parameter oder Keyboard lesen}
const ShowInfoReq:boolean=true;InModeFileReq:boolean=true;
var i:byte;L:boolean;InStr:ComStr;
begin
  InModeReq:=ParamCount=0;
  TStr:='';FStr:='';LStr:='';NStr:='';
  if InModeReq then begin
      {Keyboard lesen:}
    if ShowInfoReq then begin
      ShowInfo;
      ShowInfoReq:=false
    end;
    repeat
      ShowMenuLine(InModeFileReq);
      readln(InStr);
      L:=false;
      if (upcase(InStr[1])='D') and (length(InStr)=1) and not InModeFileReq then begin
        InModeFileReq:=true;L:=true
      end;
      if (upcase(InStr[1])='T') and (length(InStr)=1) and InModeFileReq then begin
        InModeFileReq:=false;L:=true
      end;
      if (upcase(InStr[1])='E') and (length(InStr)=1) then begin
        halt(0)
      end;
      if InModeFileReq then FStr:=InStr else TStr:=InStr
    until not L
  end;
  if not InModeReq then begin
      {Kommandozeilen-Parameter lesen:}
    for i:=1 to ParamCount do begin
      L:=false;
      if copy(ParamStr(i),1,2)='-t' then begin TStr:=copy(ParamStr(i),3,255);L:=true end;
      if copy(ParamStr(i),1,2)='-l' then begin LStr:=LogFileName;L:=true end;
      if copy(ParamStr(i),1,2)='-n' then begin NStr:='LFN';L:=true end;
      if not L and (FStr='') then FStr:=paramstr(i)
    end
  end
end;

var 
  T:text;
  F:file;FRecsRead:word;FBuf:array[1..md5BlockSize*32] of byte;
                                   {Dateipuffer: Vielfaches von md5BlockSize!}
  HashValue:array[1..MD5HashSize] of byte;
                                   {Rueckgelieferter Hashwert}
  HashFOk,HashTOk,HashNOk:boolean;
  InModeReq:boolean;
  FStr,TStr,LStr,NStr,s:ComStr;
  HashStr:string[MD5HashSize*2];
  ErrorNo,TempB:byte;FileHandle,i:word;
begin {Hauptprogramm}
  repeat
    HashStr:='';HashFOk:=false;HashTOk:=false;HashNOk:=false;

      {Kommandozeilen-Parameter oder Keyboard lesen:}
    GetCommLinePars(TStr,FStr,LStr,NStr,InModeReq);

      {Textstring hashen:}
    if length(TStr)>0 then begin
      FStr:='';HashFOk:=false;
      md5Init(@TStr[1]{!},length(TStr));
      md5Update(length(TStr));
      md5Finals(@HashValue);
      for i:=1 to MD5HashSize do HashStr:=HashStr+Byte2HStr(HashValue[i]);
      HashTOk:=true
    end;

      {Datei hashen:}
    if length(FStr)>0 then begin
      fillchar(HashValue,MD5HashSize,0);
      assign(F,FStr);
      i:=FileMode;FileMode:=0{!};
      {$I-} reset(F,1) {$I+};ErrorNo:=IOResult;
      FileMode:=byte(i);
      if ErrorNo=0 then begin
        md5Init(@FBuf,filesize(F));
        repeat
          {$I-} blockread(F,FBuf,sizeof(FBuf),FRecsRead) {$I+};ErrorNo:=IOResult;
          md5Update(sizeof(FBuf))
        until (FRecsRead=0) or (ErrorNo>0);
        md5Finals(@HashValue)
      end;
      {$I-} close(F) {$I+};TempB:=IOResult;
      for i:=1 to MD5HashSize do HashStr:=HashStr+Byte2HStr(HashValue[i]);
      HashFOk:=true
    end;

      {Hashwert auf Bildschirm ausgeben:}
    if (HashTOk or HashFOk) and (length(LStr)=0) and (length(NStr)=0) then begin
      s:='';
      if not InModeReq then if HashFOk then s:=CutDir(FStr) else s:=''''+TStr+'''';
      writeln(HashStr+' '+s)
    end;

      {Hashwert in Logdatei speichern (nicht im interaktiven Modus):}
    if (HashTOk or HashFOk) and (length(LStr)>0) and not InModeReq then begin
      if HashFOk then s:=CutDir(FStr) else s:=''''+TStr+'''';
      assign(T,LStr);
      getfattr(T,i);
      if DosError=0 then {$I-} append(T) else rewrite(T) {$I+};TempB:=IOResult;
      {$I-}
      writeln(T,HashStr+' '+s);TempB:=IOResult;
      close(T);TempB:=IOResult
      {$I+}
    end;

      {Hashwert als Dateinamen speichern (nur DOS7, nicht im interaktiven Modus):}
    if (HashTOk or HashFOk) and (length(NStr)>0) and not InModeReq then begin
      if HashFOk then s:=CutDir{!}(FStr) else s:=''''+TStr+'''';
      CreateLFNFile(HashStr+' '+s,FileHandle);
      CloseLFNFile(FileHandle)
    end
  until not InModeReq
end.
